## gitlab-ci-multi-runner 12.7.1+dfsg

=== debian/changelog ===
gitlab-ci-multi-runner (12.7.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 28 Jan 2020 19:08:25 +1100

gitlab-ci-multi-runner (12.7.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Removed unused "golang-github-pborman-uuid-dev" from Build-Depends

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 23 Jan 2020 09:20:23 +1100

gitlab-ci-multi-runner (12.6.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Renamed "debian/TODO.Debian" -> "debian/TODO".
  * Removed unused "golang-github-vbatts-tar-split-dev" from Build-Depends.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 25 Dec 2019 19:24:23 +1100

gitlab-ci-multi-runner (12.5.0+dfsg-2) unstable; urgency=medium

  * Removed "golang-github-docker-distribution-dev" from Build-Depends.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 01 Dec 2019 17:01:18 +1100

gitlab-ci-multi-runner (12.5.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 29 Nov 2019 09:34:57 +1100

gitlab-ci-multi-runner (12.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.4.1.
  * Build-Depends:
    - golang-github-juju-ratelimit-dev
    - golang-github-opencontainers-runc-dev
    - golang-github-opencontainers-specs-dev
    = golang-github-azure-go-autorest-dev (>= 10.15.5~)
    + golang-github-docker-go-units-dev
    + golang-github-gofrs-flock-dev

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 23 Oct 2019 15:31:13 +1100

gitlab-ci-multi-runner (12.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * DH & compat to version 12.
  * Added "Pre-Depends" field.
  * Build-Depends:
    = golang-github-docker-go-connections-dev (>= 0.4.0~)
    = golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    = golang-github-vbatts-tar-split-dev (>= 0.11.1~)
  * Install "git-lfs" into runner-helper image (Closes: #941033).
    Thanks, Melvin Vermeeren.

 -- Dmitry Smirnov <onlyjob@debian.org>  Tue, 24 Sep 2019 12:26:28 +1000

=== debian/control ===
Source: gitlab-ci-multi-runner
Section: devel
Priority: optional
Standards-Version: 4.4.1
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Build-Depends: debhelper-compat (= 12) ,dh-golang
              ,golang-go (>= 2:1.7~)
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-azure-go-autorest-dev (>= 10.15.5~)
    ,golang-github-blang-semver-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
    ,golang-github-docker-docker-dev (>= 17.12.1~)
#       ,golang-github-docker-distribution-dev
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-units-dev
    ,golang-github-docker-spdystream-dev
    ,golang-github-dustin-go-humanize-dev
    ,golang-github-emicklei-go-restful-dev (>= 2.4.0~)
    ,golang-github-emicklei-go-restful-swagger12-dev
    ,golang-github-getsentry-raven-go-dev
    ,golang-github-ghodss-yaml-dev
    ,golang-github-gofrs-flock-dev
    ,golang-github-go-ini-ini-dev
    ,golang-github-googleapis-gnostic-dev
    ,golang-github-google-gofuzz-dev
    ,golang-github-gophercloud-gophercloud-dev
    ,golang-github-gorhill-cronexpr-dev
    ,golang-github-gorilla-context-dev
    ,golang-github-gorilla-mux-dev
    ,golang-github-hashicorp-go-version-dev
    ,golang-github-howeyc-gopass-dev
    ,golang-github-imdario-mergo-dev
    ,golang-github-jpillora-backoff-dev
    ,golang-github-json-iterator-go-dev
    ,golang-github-mattn-go-zglob-dev
    ,golang-github-minio-minio-go-dev (>= 6.0.11~)
    ,golang-github-pkg-errors-dev
    ,golang-github-pmezard-go-difflib-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.6~)
    ,golang-github-spf13-pflag-dev
    ,golang-github-stretchr-testify-dev (>= 1.2.1~)
    ,golang-github-urfave-cli-dev
    ,golang-golang-x-crypto-dev
    ,golang-golang-x-oauth2-google-dev
    ,golang-gopkg-inf.v0-dev
    ,golang-yaml.v2-dev
# tests:
    ,ca-certificates
    ,git
    ,golang-github-golang-mock-dev
    ,tzdata
Homepage: https://gitlab.com/gitlab-org/gitlab-runner
Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner
Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-ci-multi-runner.git
XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-ci-multi-runner

Package: gitlab-runner
Provides: gitlab-ci-multi-runner
Conflicts: gitlab-ci-multi-runner
Breaks: gitlab-ci-multi-runner
Replaces: gitlab-ci-multi-runner
Architecture: any
Built-Using: ${misc:Built-Using}
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
    ,adduser
    ,ca-certificates
#    ,curl
    ,git
    ,lsb-base
Recommends: ${misc:Recommends}
    ,cdebootstrap
    ,xz-utils
Suggests: ${misc:Suggests}
    ,docker.io
Description: GitLab Runner - runs continuous integration (CI) jobs
 GitLab Runner runs tests and sends the results to GitLab.
 GitLab Continuous Integration (CI) service (included with GitLab)
 coordinates the testing.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
VER  ?= $(shell sh -c 'printf "$${1%%+dfsg*}"' -- "$(DEB_VERSION_UPSTREAM)")

export DH_GOLANG_GO_GENERATE := 1
export DH_GOPKG = gitlab.com/gitlab-org/gitlab-runner
export DH_GOPKG_common = $(DH_GOPKG)/common
#export DH_GOLANG_INSTALL_EXTRA := vendor
#export DH_GOLANG_INSTALL_ALL := 1
#export DH_GOLANG_EXCLUDES = apps/gitlab-runner-helper

## Set some build variables as per Makefile:
GO_LDFLAGS ?= \
    -X $(DH_GOPKG_common).VERSION=$(VER) \
    -X $(DH_GOPKG_common).REVISION=$(VER)
#    -X $(DH_GOPKG_common).NAME=$(DEB_SOURCE)
#    -X $(DH_GOPKG_common).BUILT=$(BUILT)
#    -X $(DH_GOPKG_common).BRANCH=$(BRANCH)

MKPI=debian/mk-prebuilt-images.sh

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean $(MKPI)
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
	-find vendor -type d -empty -delete -print
	-find . -type f -name '*.generated.go' -print -delete ## delete .generated.go files

$(MKPI):
	sed -e 's/__VERSION__/$(VER)/g' $@.in > $@
	chmod --reference=$@.in $@

GITDIR=_build/src/$(DH_GOPKG)/tmp/gitlab-test
$(GITDIR):
	mkdir -v -p $@
	cd $@ && git init

override_dh_auto_configure: $(MKPI) $(GITDIR)
	dh_auto_configure

override_dh_auto_build:
	dh_auto_build --parallel -- \
            -ldflags "$(GO_LDFLAGS)"

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_auto_test:
	mkdir -v -p $(CURDIR)/debian/tmp
	HOME=$(CURDIR)/debian/tmp \
        dh_auto_test --max-parallel=4 -- \
            -ldflags "$(GO_LDFLAGS)"
#-test.short

override_dh_dwz:
	:

## gitlab-ci-multi-runner 13.3.1+dfsg

=== Makefile ===
NAME ?= gitlab-runner
export PACKAGE_NAME ?= $(NAME)
export VERSION := $(shell ./ci/version)
REVISION := $(shell git rev-parse --short=8 HEAD || echo unknown)
BRANCH := $(shell git show-ref | grep "$(REVISION)" | grep -v HEAD | awk '{print $$2}' | sed 's|refs/remotes/origin/||' | sed 's|refs/heads/||' | sort | head -n 1)
BUILT := $(shell date -u +%Y-%m-%dT%H:%M:%S%z)
export TESTFLAGS ?= -cover

LATEST_STABLE_TAG := $(shell git -c versionsort.prereleaseSuffix="-rc" -c versionsort.prereleaseSuffix="-RC" tag -l "v*.*.*" --sort=-v:refname | awk '!/rc/' | head -n 1)
export IS_LATEST :=
ifeq ($(shell git describe --exact-match --match $(LATEST_STABLE_TAG) >/dev/null 2>&1; echo $$?), 0)
export IS_LATEST := true
endif

PACKAGE_CLOUD ?= ayufan/gitlab-ci-multi-runner
PACKAGE_CLOUD_URL ?= https://packagecloud.io/
BUILD_ARCHS ?= -arch '386' -arch 'arm' -arch 'amd64' -arch 'arm64' -arch 's390x'
BUILD_PLATFORMS ?= -osarch 'darwin/amd64' -os 'linux' -os 'freebsd' -os 'windows' ${BUILD_ARCHS}
S3_UPLOAD_PATH ?= master

# Keep in sync with docs/install/linux-repository.md
DEB_PLATFORMS ?= debian/jessie debian/stretch debian/buster \
    ubuntu/xenial ubuntu/bionic ubuntu/eoan ubuntu/focal \
    raspbian/jessie raspbian/stretch raspbian/buster \
    linuxmint/sarah linuxmint/serena linuxmint/sonya
DEB_ARCHS ?= amd64 i386 armel armhf arm64 aarch64 s390x
RPM_PLATFORMS ?= el/6 el/7 el/8 \
    ol/6 ol/7 \
    fedora/30
RPM_ARCHS ?= x86_64 i686 arm armhf arm64 aarch64 s390x

PKG = gitlab.com/gitlab-org/$(PACKAGE_NAME)
COMMON_PACKAGE_NAMESPACE=$(PKG)/common

BUILD_DIR := $(CURDIR)
TARGET_DIR := $(BUILD_DIR)/out

# Packages in vendor/ are included in ./...
# https://github.com/golang/go/issues/11659
export OUR_PACKAGES ?= $(subst _$(BUILD_DIR),$(PKG),$(shell go list ./... | grep -v '/vendor/'))

GO_LDFLAGS ?= -X $(COMMON_PACKAGE_NAMESPACE).NAME=$(PACKAGE_NAME) -X $(COMMON_PACKAGE_NAMESPACE).VERSION=$(VERSION) \
              -X $(COMMON_PACKAGE_NAMESPACE).REVISION=$(REVISION) -X $(COMMON_PACKAGE_NAMESPACE).BUILT=$(BUILT) \
              -X $(COMMON_PACKAGE_NAMESPACE).BRANCH=$(BRANCH) \
              -s -w
GO_FILES ?= $(shell find . -name '*.go')
export CGO_ENABLED ?= 0


# Development Tools
GOX = gox

MOCKERY_VERSION ?= 1.1.0
MOCKERY ?= .tmp/mockery-$(MOCKERY_VERSION)

GOLANGLINT_VERSION ?= v1.27.0
GOLANGLINT ?= .tmp/golangci-lint$(GOLANGLINT_VERSION)
GOLANGLINT_GOARGS ?= .tmp/goargs.so

DEVELOPMENT_TOOLS = $(GOX) $(MOCKERY)

RELEASE_INDEX_GEN_VERSION ?= latest
RELEASE_INDEX_GENERATOR ?= .tmp/release-index-gen-$(RELEASE_INDEX_GEN_VERSION)
GITLAB_CHANGELOG_VERSION ?= latest
GITLAB_CHANGELOG = .tmp/gitlab-changelog-$(GITLAB_CHANGELOG_VERSION)

.PHONY: all
all: deps runner-and-helper-bin

include Makefile.deprecation.mk
include Makefile.runner_helper.mk
include Makefile.build.mk
include Makefile.package.mk

.PHONY: help
help:
	# Commands:
	# make all => install deps and build Runner binaries and Helper images
	# make version - show information about current version
	#
	# Development commands:
	# make development_setup - setup needed environment for tests
	# make runner-bin-host - build executable for your arch and OS
	# make runner-and-helper-bin-host - build executable for your arch and OS, including docker dependencies
	# make runner-and-helper-bin - build executable for all supported platforms, including docker dependencies
	# make helper-dockerarchive - build Runner Helper docker dependencies for all supported platforms
	#
	# Testing commands:
	# make test - run project tests
	# make lint - run code quality analysis
	# make lint-docs - run documentation linting
	#
	# Deployment commands:
	# make deps - install all dependencies
	# make runner-bin - build project for all supported platforms
	# make package - package project using FPM
	# make packagecloud - send all packages to packagecloud
	# make packagecloud-yank - remove specific version from packagecloud

.PHONY: version
version:
	@echo Current version: $(VERSION)
	@echo Current revision: $(REVISION)
	@echo Current branch: $(BRANCH)
	@echo Build platforms: $(BUILD_PLATFORMS)
	@echo DEB platforms: $(DEB_PLATFORMS)
	@echo RPM platforms: $(RPM_PLATFORMS)
	@echo IS_LATEST: $(IS_LATEST)

.PHONY: deps
deps: $(DEVELOPMENT_TOOLS)

.PHONY: lint
lint: OUT_FORMAT ?= colored-line-number
lint: LINT_FLAGS ?=
lint: $(GOLANGLINT)
	@$(GOLANGLINT) run ./... --out-format $(OUT_FORMAT) $(LINT_FLAGS)

.PHONY: lint-docs
lint-docs:
	@scripts/lint-docs

check_race_conditions:
	@./scripts/check_race_conditions $(OUR_PACKAGES)

.PHONY: test
test: helper-dockerarchive-host development_setup simple-test

simple-test:
	go test $(OUR_PACKAGES) $(TESTFLAGS)

parallel_test_prepare:
	# Preparing test commands
	@./scripts/go_test_with_coverage_report prepare

parallel_test_execute: pull_images_for_tests
	# executing tests
	@./scripts/go_test_with_coverage_report execute

parallel_test_coverage_report:
	# Preparing coverage report
	@./scripts/go_test_with_coverage_report coverage

parallel_test_junit_report:
	# Preparing jUnit test report
	@./scripts/go_test_with_coverage_report junit

pull_images_for_tests:
	# Pulling images required for some tests
	@go run ./scripts/pull-images-for-tests/main.go

dockerfiles:
	$(MAKE) -C dockerfiles all

.PHONY: mocks
mocks: $(MOCKERY)
	rm -rf ./helpers/service/mocks
	find . -type f ! -path '*vendor/*' -name 'mock_*' -delete
	$(MOCKERY) -dir=./vendor/github.com/ayufan/golang-kardianos-service -output=./helpers/service/mocks -name='(Interface)'
	$(MOCKERY) -dir=./network -name='requester' -inpkg
	$(MOCKERY) -dir=./helpers -all -inpkg
	$(MOCKERY) -dir=./executors/docker -all -inpkg
	$(MOCKERY) -dir=./executors/kubernetes -all -inpkg
	$(MOCKERY) -dir=./executors/custom -all -inpkg
	$(MOCKERY) -dir=./cache -all -inpkg
	$(MOCKERY) -dir=./common -all -inpkg
	$(MOCKERY) -dir=./log -all -inpkg
	$(MOCKERY) -dir=./referees -all -inpkg
	$(MOCKERY) -dir=./session -all -inpkg
	$(MOCKERY) -dir=./shells -all -inpkg
	$(MOCKERY) -dir=./commands/helpers -all -inpkg

check_mocks:
	# Checking if mocks are up-to-date
	@$(MAKE) mocks
	# Checking the differences
	@git --no-pager diff --compact-summary --exit-code -- ./helpers/service/mocks \
		$(shell git ls-files | grep 'mock_' | grep -v 'vendor/') && \
		echo "Mocks up-to-date!"

test-docker:
	$(MAKE) test-docker-image IMAGE=centos:6 TYPE=rpm
	$(MAKE) test-docker-image IMAGE=centos:7 TYPE=rpm
	$(MAKE) test-docker-image IMAGE=debian:wheezy TYPE=deb
	$(MAKE) test-docker-image IMAGE=debian:jessie TYPE=deb
	$(MAKE) test-docker-image IMAGE=ubuntu-upstart:precise TYPE=deb
	$(MAKE) test-docker-image IMAGE=ubuntu-upstart:trusty TYPE=deb
	$(MAKE) test-docker-image IMAGE=ubuntu-upstart:utopic TYPE=deb

test-docker-image:
	tests/test_installation.sh $(IMAGE) out/$(TYPE)/$(PACKAGE_NAME)_amd64.$(TYPE)
	tests/test_installation.sh $(IMAGE) out/$(TYPE)/$(PACKAGE_NAME)_amd64.$(TYPE) Y

build-and-deploy: ARCH ?= amd64
build-and-deploy:
	$(MAKE) runner-and-helper-bin BUILD_PLATFORMS="-osarch=linux/$(ARCH)"
	$(MAKE) package-deb-arch ARCH=$(ARCH) PACKAGE_ARCH=$(ARCH)
	@[ -z "$(SERVER)" ] && echo "SERVER variable not specified!" && exit 1
	scp out/deb/$(PACKAGE_NAME)_$(ARCH).deb $(SERVER):
	ssh $(SERVER) dpkg -i $(PACKAGE_NAME)_$(ARCH).deb

build-and-deploy-binary: ARCH ?= amd64
build-and-deploy-binary:
	$(MAKE) runner-bin BUILD_PLATFORMS="-osarch=linux/$(ARCH)"
	@[ -z "$(SERVER)" ] && echo "SERVER variable not specified!" && exit 1
	scp out/binaries/$(PACKAGE_NAME)-linux-$(ARCH) $(SERVER):/usr/bin/gitlab-runner

.PHONY: packagecloud
packagecloud: packagecloud-deps packagecloud-deb packagecloud-rpm

packagecloud-deps:
	# Installing packagecloud dependencies...
	gem install package_cloud --version "~> 0.3.0" --no-document

packagecloud-deb:
	# Sending Debian compatible packages...
	-for DIST in $(DEB_PLATFORMS); do \
		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
	done

packagecloud-rpm:
	# Sending RedHat compatible packages...
	-for DIST in $(RPM_PLATFORMS); do \
		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/rpm/*.rpm; \
	done

packagecloud-yank:
ifneq ($(YANK),)
	# Removing $(YANK) from packagecloud...
	-for DIST in $(DEB_PLATFORMS); do \
		for ARCH in $(DEB_ARCHS); do \
			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)_$(YANK)_$$ARCH.deb & \
		done; \
	done; \
	for DIST in $(RPM_PLATFORMS); do \
		for ARCH in $(RPM_ARCHS); do \
			package_cloud yank --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST $(PACKAGE_NAME)-$(YANK)-1.$$ARCH.rpm & \
		done; \
	done; \
	wait
else
	# No version specified in YANK
	@exit 1
endif

s3-upload:
	export ARTIFACTS_DEST=artifacts; curl -sL https://raw.githubusercontent.com/travis-ci/artifacts/master/install | bash
	./artifacts upload \
		--permissions public-read \
		--working-dir out \
		--target-paths "$(S3_UPLOAD_PATH)/" \
		--max-size $(shell du -bs out/ | cut -f1) \
		$(shell cd out/; find . -type f)
	@echo "\n\033[1m==> Download index file: \033[36mhttps://$$ARTIFACTS_S3_BUCKET.s3.amazonaws.com/$$S3_UPLOAD_PATH/index.html\033[0m\n"

release_packagecloud:
	# Releasing to https://packages.gitlab.com/runner/
	@./ci/release_packagecloud "$$CI_JOB_NAME"

release_s3: prepare_windows_zip prepare_zoneinfo prepare_index
	# Releasing to S3
	@./ci/release_s3

out/binaries/gitlab-runner-windows-%.zip: out/binaries/gitlab-runner-windows-%.exe
	zip --junk-paths $@ $<
	cd out/ && zip -r ../$@ helper-images

prepare_windows_zip: out/binaries/gitlab-runner-windows-386.zip out/binaries/gitlab-runner-windows-amd64.zip

prepare_zoneinfo:
	# preparing the zoneinfo file
	@cp $$GOROOT/lib/time/zoneinfo.zip out/

prepare_index: export CI_COMMIT_REF_NAME ?= $(BRANCH)
prepare_index: export CI_COMMIT_SHA ?= $(REVISION)
prepare_index: $(RELEASE_INDEX_GENERATOR)
	# Preparing index file
	@$(RELEASE_INDEX_GENERATOR) -working-directory out/ \
								-project-version $(VERSION) \
								-project-git-ref $(CI_COMMIT_REF_NAME) \
								-project-git-revision $(CI_COMMIT_SHA) \
								-project-name "GitLab Runner" \
								-project-repo-url "https://gitlab.com/gitlab-org/gitlab-runner" \
								-gpg-key-env GPG_KEY \
								-gpg-password-env GPG_PASSPHRASE

release_docker_images:
	# Releasing Docker images
	@./ci/release_docker_images

generate_changelog: export CHANGELOG_RELEASE ?= $(VERSION)
generate_changelog: $(GITLAB_CHANGELOG)
	# Generating new changelog entries
	@$(GITLAB_CHANGELOG) -project-id 250833 \
		-release $(CHANGELOG_RELEASE) \
		-starting-point-matcher "v[0-9]*.[0-9]*.[0-9]*" \
		-config-file .gitlab/changelog.yml \
		-changelog-file CHANGELOG.md

check-tags-in-changelog:
	# Looking for tags in CHANGELOG
	@git status | grep "On branch master" 2>&1 >/dev/null || echo "Check should be done on master branch only. Skipping."
	@for tag in $$(git tag | grep -E "^v[0-9]+\.[0-9]+\.[0-9]+$$" | sed 's|v||' | sort -g); do \
		state="MISSING"; \
		grep "^v $$tag" CHANGELOG.md 2>&1 >/dev/null; \
		[ "$$?" -eq 1 ] || state="OK"; \
		echo "$$tag:   \t $$state"; \
	done

update_feature_flags_docs:
	go run ./scripts/update-feature-flags-docs/main.go

development_setup:
	test -d tmp/gitlab-test || git clone https://gitlab.com/gitlab-org/ci-cd/tests/gitlab-test.git tmp/gitlab-test
	if prlctl --version ; then $(MAKE) -C tests/ubuntu parallels ; fi
	if vboxmanage --version ; then $(MAKE) -C tests/ubuntu virtualbox ; fi

check_modules:
	# Check if there is any difference in vendor/
	@git status -sb vendor/ > /tmp/vendor-$${CI_JOB_ID}-before
	@go mod vendor
	@git status -sb vendor/ > /tmp/vendor-$${CI_JOB_ID}-after
	@diff -U0 /tmp/vendor-$${CI_JOB_ID}-before /tmp/vendor-$${CI_JOB_ID}-after

	# check go.sum
	@git diff go.sum > /tmp/gosum-$${CI_JOB_ID}-before
	@go mod tidy
	@git diff go.sum > /tmp/gosum-$${CI_JOB_ID}-after
	@diff -U0 /tmp/gosum-$${CI_JOB_ID}-before /tmp/gosum-$${CI_JOB_ID}-after

# development tools
$(GOX):
	go get github.com/mitchellh/gox

$(GOLANGLINT): TOOL_BUILD_DIR := .tmp/build/golangci-lint

=== debian/changelog ===
gitlab-ci-multi-runner (13.3.1+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Add golang-google-cloud-dev to Build-Depends
  * Exclude scripts dir when building.
    This drops two test binaries:
    + /usr/bin/update-feature-flags-docs
    + /usr/bin/pull-images-for-tests

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 17 Jan 2021 19:52:33 +0800

gitlab-ci-multi-runner (13.3.1+dfsg-3) unstable; urgency=medium

  * Team upload.
  * New patch to fix FTBFS on 32-bit architectures
    from https://gitlab.com/gitlab-org/gitlab-runner/-/merge_requests/2597
    "remove test with int overflow"

 -- Anthony Fok <foka@debian.org>  Tue, 22 Dec 2020 09:12:30 -0700

gitlab-ci-multi-runner (13.3.1+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Dmitry Smirnov ]
  * Recommends += git-lfs
  * README.Debian: documented integration with Docker (Closes: #971520)

  [ Daniel Gomez ]
  * README.Debian: Fix typo.

  [ Arnaud Rebillout ]
  * Build-Depends += golang-github-kr-pty-dev
    to fix FTBFS

  [ Anthony Fok ]
  * Build-Depends on golang-any (>= 2:1.13~) as per go.mod
  * New patch to fix FTBFS due to added argument in ContainerCreate() with
    golang-github-docker-docker-dev (>= 20.10.0~beta1)

 -- Anthony Fok <foka@debian.org>  Tue, 22 Dec 2020 06:50:20 -0700

gitlab-ci-multi-runner (13.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Use private "github.com/prometheus/client_golang" (Closes: #964639)

  [ Shengjing Zhu ]
  * Bump golang-github-azure-go-autorest-dev to 14.1.1 (Closes: #964872)

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 10 Sep 2020 21:47:53 +1000

gitlab-ci-multi-runner (13.0.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Build-Depends += "golang-github-bmatcuk-doublestar-dev".

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 03 Jun 2020 15:52:27 +1000

gitlab-ci-multi-runner (12.10.2+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 18 May 2020 08:28:34 +1000

gitlab-ci-multi-runner (12.9.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.5.0.
  * Disabled failing tests (Closes: #954522).

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 15 Apr 2020 10:03:22 +1000

gitlab-ci-multi-runner (12.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 27 Feb 2020 12:10:35 +1100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: gitlab-ci-multi-runner
 Section: devel
 Priority: optional
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
-Uploaders: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Uploaders: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Build-Depends: debhelper-compat (= 12) ,dh-golang
-              ,golang-go (>= 2:1.7~)
+              ,golang-any (>= 2:1.13~)
     ,golang-github-azure-go-ansiterm-dev
-    ,golang-github-azure-go-autorest-dev (>= 10.15.5~)
+    ,golang-github-azure-go-autorest-dev (>= 14.1.1~)
     ,golang-github-blang-semver-dev
+    ,golang-github-bmatcuk-doublestar-dev
     ,golang-github-burntsushi-toml-dev
     ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
-    ,golang-github-docker-docker-dev (>= 17.12.1~)
+    ,golang-github-docker-docker-dev (>= 20.10.0~beta1)
 #       ,golang-github-docker-distribution-dev
     ,golang-github-docker-go-connections-dev (>= 0.4.0~)
     ,golang-github-docker-go-units-dev
@@ -34,6 +35,7 @@
     ,golang-github-imdario-mergo-dev
     ,golang-github-jpillora-backoff-dev
     ,golang-github-json-iterator-go-dev
+    ,golang-github-kr-pty-dev
     ,golang-github-mattn-go-zglob-dev
     ,golang-github-minio-minio-go-dev (>= 6.0.11~)
     ,golang-github-pkg-errors-dev
@@ -45,6 +47,8 @@
     ,golang-github-urfave-cli-dev
     ,golang-golang-x-crypto-dev
     ,golang-golang-x-oauth2-google-dev
+    ,golang-golang-x-sync-dev
+    ,golang-google-cloud-dev
     ,golang-gopkg-inf.v0-dev
     ,golang-yaml.v2-dev
 # tests:
@@ -74,6 +78,7 @@
     ,lsb-base
 Recommends: ${misc:Recommends}
     ,cdebootstrap
+    ,git-lfs
     ,xz-utils
 Suggests: ${misc:Suggests}
     ,docker.io

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 export DH_GOPKG_common = $(DH_GOPKG)/common
 #export DH_GOLANG_INSTALL_EXTRA := vendor
 #export DH_GOLANG_INSTALL_ALL := 1
-#export DH_GOLANG_EXCLUDES = apps/gitlab-runner-helper
+export DH_GOLANG_EXCLUDES = executors/kubernetes scripts
 
 ## Set some build variables as per Makefile:
 GO_LDFLAGS ?= \
@@ -55,6 +55,3 @@
         dh_auto_test --max-parallel=4 -- \
             -ldflags "$(GO_LDFLAGS)"
 #-test.short
-
-override_dh_dwz:
-	:

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://gitlab.com/gitlab-org/gitlab-runner/-/tags \
  .*/v?(\d[\.\d]*)/gitlab-runner-v?(?:\d[\.\d]*)\.tar\.bz2

## gitlab-ci-multi-runner 14.10.1

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 BUILT := $(shell date -u +%Y-%m-%dT%H:%M:%S%z)
 export TESTFLAGS ?= -cover
 
-LATEST_STABLE_TAG := $(shell git -c versionsort.prereleaseSuffix="-rc" -c versionsort.prereleaseSuffix="-RC" tag -l "v*.*.*" --sort=-v:refname | awk '!/rc/' | head -n 1)
+LATEST_STABLE_TAG := $(shell git -c versionsort.prereleaseSuffix="-rc" -c versionsort.prereleaseSuffix="-RC" tag -l "v*.*.*" | sort -rV | awk '!/rc/' | head -n 1)
 export IS_LATEST :=
 ifeq ($(shell git describe --exact-match --match $(LATEST_STABLE_TAG) >/dev/null 2>&1; echo $$?), 0)
 export IS_LATEST := true
@@ -14,46 +14,47 @@
 
 PACKAGE_CLOUD ?= ayufan/gitlab-ci-multi-runner
 PACKAGE_CLOUD_URL ?= https://packagecloud.io/
-BUILD_ARCHS ?= -arch '386' -arch 'arm' -arch 'amd64' -arch 'arm64' -arch 's390x'
-BUILD_PLATFORMS ?= -osarch 'darwin/amd64' -os 'linux' -os 'freebsd' -os 'windows' ${BUILD_ARCHS}
-S3_UPLOAD_PATH ?= master
+BUILD_ARCHS ?= -arch '386' -arch 'arm' -arch 'amd64' -arch 'arm64' -arch 's390x' -arch 'ppc64le'
+BUILD_PLATFORMS ?= -osarch 'darwin/amd64' -osarch 'darwin/arm64' -os 'linux' -os 'freebsd' -os 'windows' ${BUILD_ARCHS}
+S3_UPLOAD_PATH ?= main
 
 # Keep in sync with docs/install/linux-repository.md
-DEB_PLATFORMS ?= debian/jessie debian/stretch debian/buster \
-    ubuntu/xenial ubuntu/bionic ubuntu/eoan ubuntu/focal \
+DEB_PLATFORMS ?= debian/stretch debian/buster debian/bullseye \
+    ubuntu/xenial ubuntu/bionic ubuntu/focal \
     raspbian/jessie raspbian/stretch raspbian/buster \
     linuxmint/sarah linuxmint/serena linuxmint/sonya
-DEB_ARCHS ?= amd64 i386 armel armhf arm64 aarch64 s390x
+DEB_ARCHS ?= amd64 i386 armel armhf arm64 aarch64 s390x ppc64le
 RPM_PLATFORMS ?= el/6 el/7 el/8 \
     ol/6 ol/7 \
-    fedora/30
-RPM_ARCHS ?= x86_64 i686 arm armhf arm64 aarch64 s390x
+    fedora/32 fedora/33 fedora/34 \
+    amazon/2
+RPM_ARCHS ?= x86_64 i686 arm armhf arm64 aarch64 s390x ppc64le
 
 PKG = gitlab.com/gitlab-org/$(PACKAGE_NAME)
-COMMON_PACKAGE_NAMESPACE=$(PKG)/common
+COMMON_PACKAGE_NAMESPACE = $(PKG)/common
 
 BUILD_DIR := $(CURDIR)
 TARGET_DIR := $(BUILD_DIR)/out
 
-# Packages in vendor/ are included in ./...
-# https://github.com/golang/go/issues/11659
-export OUR_PACKAGES ?= $(subst _$(BUILD_DIR),$(PKG),$(shell go list ./... | grep -v '/vendor/'))
+export MAIN_PACKAGE ?= gitlab.com/gitlab-org/gitlab-runner
 
 GO_LDFLAGS ?= -X $(COMMON_PACKAGE_NAMESPACE).NAME=$(PACKAGE_NAME) -X $(COMMON_PACKAGE_NAMESPACE).VERSION=$(VERSION) \
               -X $(COMMON_PACKAGE_NAMESPACE).REVISION=$(REVISION) -X $(COMMON_PACKAGE_NAMESPACE).BUILT=$(BUILT) \
               -X $(COMMON_PACKAGE_NAMESPACE).BRANCH=$(BRANCH) \
-              -s -w
+              -w
 GO_FILES ?= $(shell find . -name '*.go')
 export CGO_ENABLED ?= 0
 
 
 # Development Tools
+GOCOVER_COBERTURA = gocover-cobertura
+
 GOX = gox
 
 MOCKERY_VERSION ?= 1.1.0
 MOCKERY ?= .tmp/mockery-$(MOCKERY_VERSION)
 
-GOLANGLINT_VERSION ?= v1.27.0
+GOLANGLINT_VERSION ?= v1.43.0
 GOLANGLINT ?= .tmp/golangci-lint$(GOLANGLINT_VERSION)
 GOLANGLINT_GOARGS ?= .tmp/goargs.so
 
@@ -67,7 +68,6 @@
 .PHONY: all
 all: deps runner-and-helper-bin
 
-include Makefile.deprecation.mk
 include Makefile.runner_helper.mk
 include Makefile.build.mk
 include Makefile.package.mk
@@ -82,8 +82,11 @@
 	# make development_setup - setup needed environment for tests
 	# make runner-bin-host - build executable for your arch and OS
 	# make runner-and-helper-bin-host - build executable for your arch and OS, including docker dependencies
+	# make runner-and-helper-bin-linux - build executable for all supported architectures for linux OS, including docker dependencies
 	# make runner-and-helper-bin - build executable for all supported platforms, including docker dependencies
+	# make runner-and-helper-docker-host - build Alpine and Ubuntu Docker images with the runner executable and helper
 	# make helper-dockerarchive - build Runner Helper docker dependencies for all supported platforms
+	# make helper-dockerarchive-host - build Runner Helper docker dependencies for your oarch and OS
 	#
 	# Testing commands:
 	# make test - run project tests
@@ -110,10 +113,15 @@
 .PHONY: deps
 deps: $(DEVELOPMENT_TOOLS)
 
+.PHONY: check_test_directives
+check_test_directives:
+	@scripts/check_test_directives
+
 .PHONY: lint
 lint: OUT_FORMAT ?= colored-line-number
 lint: LINT_FLAGS ?=
 lint: $(GOLANGLINT)
+	@$(MAKE) check_test_directives >/dev/stderr
 	@$(GOLANGLINT) run ./... --out-format $(OUT_FORMAT) $(LINT_FLAGS)
 
 .PHONY: lint-docs
@@ -121,20 +129,40 @@
 	@scripts/lint-docs
 
 check_race_conditions:
-	@./scripts/check_race_conditions $(OUR_PACKAGES)
+	@./scripts/check_race_conditions
 
 .PHONY: test
 test: helper-dockerarchive-host development_setup simple-test
 
+simple-test: TEST_PKG ?= $(shell go list ./...)
 simple-test:
-	go test $(OUR_PACKAGES) $(TESTFLAGS)
+	# use env -i to clear parent environment variables for go test
+	./scripts/go_test_no_env $(TEST_PKG) $(TESTFLAGS) -ldflags "$(GO_LDFLAGS)"
+
+git1.8-test: export TEST_PKG = gitlab.com/gitlab-org/gitlab-runner/executors/shell gitlab.com/gitlab-org/gitlab-runner/shells
+git1.8-test:
+	$(MAKE) simple-test TESTFLAGS='-cover -tags=integration'
+	$(MAKE) simple-test
+
+cobertura_report: $(GOCOVER_COBERTURA)
+	mkdir -p out/cobertura
+	$(GOCOVER_COBERTURA) < out/coverage/coverprofile.regular.source.txt > out/cobertura/cobertura-coverage-raw.xml
+	@ # NOTE: Remove package paths.
+	@ # See https://gitlab.com/gitlab-org/gitlab/-/issues/217664
+	sed 's;filename=\"gitlab.com/gitlab-org/gitlab-runner/;filename=\";g' out/cobertura/cobertura-coverage-raw.xml > \
+	  out/cobertura/cobertura-coverage.xml
+
+export_test_env:
+	@echo "export GO_LDFLAGS='$(GO_LDFLAGS)'"
+	@echo "export MAIN_PACKAGE='$(MAIN_PACKAGE)'"
 
 parallel_test_prepare:
 	# Preparing test commands
 	@./scripts/go_test_with_coverage_report prepare
 
+parallel_test_execute: export GO_LDFLAGS ?= "$(GO_LDFLAGS)"
 parallel_test_execute: pull_images_for_tests
-	# executing tests
+	# Executing tests
 	@./scripts/go_test_with_coverage_report execute
 
 parallel_test_coverage_report:
@@ -145,6 +173,10 @@
 	# Preparing jUnit test report
 	@./scripts/go_test_with_coverage_report junit
 
+check_windows_test_ignore_list:
+	# Checking for orphaned test names in ignore file
+	@./scripts/check_windows_test_ignore_list
+
 pull_images_for_tests:
 	# Pulling images required for some tests
 	@go run ./scripts/pull-images-for-tests/main.go
@@ -155,8 +187,7 @@
 .PHONY: mocks
 mocks: $(MOCKERY)
 	rm -rf ./helpers/service/mocks
-	find . -type f ! -path '*vendor/*' -name 'mock_*' -delete
-	$(MOCKERY) -dir=./vendor/github.com/ayufan/golang-kardianos-service -output=./helpers/service/mocks -name='(Interface)'
+	find . -type f -name 'mock_*' -delete
 	$(MOCKERY) -dir=./network -name='requester' -inpkg
 	$(MOCKERY) -dir=./helpers -all -inpkg
 	$(MOCKERY) -dir=./executors/docker -all -inpkg
@@ -175,7 +206,8 @@
 	@$(MAKE) mocks
 	# Checking the differences
 	@git --no-pager diff --compact-summary --exit-code -- ./helpers/service/mocks \
-		$(shell git ls-files | grep 'mock_' | grep -v 'vendor/') && \
+		$(shell git ls-files | grep 'mock_') && \
+		!(git ls-files -o | grep 'mock_') && \
 		echo "Mocks up-to-date!"
 
 test-docker:
@@ -214,15 +246,11 @@
 
 packagecloud-deb:
 	# Sending Debian compatible packages...
-	-for DIST in $(DEB_PLATFORMS); do \
-		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/deb/*.deb; \
-	done
+	@-./ci/push_packagecloud $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD) deb $(DEB_PLATFORMS)
 
 packagecloud-rpm:
 	# Sending RedHat compatible packages...
-	-for DIST in $(RPM_PLATFORMS); do \
-		package_cloud push --url $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD)/$$DIST out/rpm/*.rpm; \
-	done
+	@-./ci/push_packagecloud $(PACKAGE_CLOUD_URL) $(PACKAGE_CLOUD) rpm $(RPM_PLATFORMS)
 
 packagecloud-yank:
 ifneq ($(YANK),)
@@ -269,7 +297,7 @@
 
 prepare_zoneinfo:
 	# preparing the zoneinfo file
-	@cp $$GOROOT/lib/time/zoneinfo.zip out/
+	@cp $(shell go env GOROOT)/lib/time/zoneinfo.zip out/
 
 prepare_index: export CI_COMMIT_REF_NAME ?= $(BRANCH)
 prepare_index: export CI_COMMIT_SHA ?= $(REVISION)
@@ -285,8 +313,12 @@
 								-gpg-password-env GPG_PASSPHRASE
 
 release_docker_images:
-	# Releasing Docker images
+	# Releasing GitLab Runner images
 	@./ci/release_docker_images
+
+release_helper_docker_images:
+	# Releasing GitLab Runner Helper images
+	@./ci/release_helper_docker_images
 
 generate_changelog: export CHANGELOG_RELEASE ?= $(VERSION)
 generate_changelog: $(GITLAB_CHANGELOG)
@@ -294,42 +326,3 @@
 	@$(GITLAB_CHANGELOG) -project-id 250833 \
 		-release $(CHANGELOG_RELEASE) \
 		-starting-point-matcher "v[0-9]*.[0-9]*.[0-9]*" \
-		-config-file .gitlab/changelog.yml \
-		-changelog-file CHANGELOG.md
-
-check-tags-in-changelog:
-	# Looking for tags in CHANGELOG
-	@git status | grep "On branch master" 2>&1 >/dev/null || echo "Check should be done on master branch only. Skipping."
-	@for tag in $$(git tag | grep -E "^v[0-9]+\.[0-9]+\.[0-9]+$$" | sed 's|v||' | sort -g); do \
-		state="MISSING"; \
-		grep "^v $$tag" CHANGELOG.md 2>&1 >/dev/null; \
-		[ "$$?" -eq 1 ] || state="OK"; \
-		echo "$$tag:   \t $$state"; \
-	done
-
-update_feature_flags_docs:
-	go run ./scripts/update-feature-flags-docs/main.go
-
-development_setup:
-	test -d tmp/gitlab-test || git clone https://gitlab.com/gitlab-org/ci-cd/tests/gitlab-test.git tmp/gitlab-test
-	if prlctl --version ; then $(MAKE) -C tests/ubuntu parallels ; fi
-	if vboxmanage --version ; then $(MAKE) -C tests/ubuntu virtualbox ; fi
-
-check_modules:
-	# Check if there is any difference in vendor/
-	@git status -sb vendor/ > /tmp/vendor-$${CI_JOB_ID}-before
-	@go mod vendor
-	@git status -sb vendor/ > /tmp/vendor-$${CI_JOB_ID}-after
-	@diff -U0 /tmp/vendor-$${CI_JOB_ID}-before /tmp/vendor-$${CI_JOB_ID}-after
-
-	# check go.sum
-	@git diff go.sum > /tmp/gosum-$${CI_JOB_ID}-before
-	@go mod tidy
-	@git diff go.sum > /tmp/gosum-$${CI_JOB_ID}-after
-	@diff -U0 /tmp/gosum-$${CI_JOB_ID}-before /tmp/gosum-$${CI_JOB_ID}-after
-
-# development tools
-$(GOX):
-	go get github.com/mitchellh/gox
-
-$(GOLANGLINT): TOOL_BUILD_DIR := .tmp/build/golangci-lint

=== debian/changelog ===
gitlab-ci-multi-runner (14.10.1-1) unstable; urgency=medium

  * New upstream release.
    + fixed CVE-2020-13327 (Closes: #985377).
    + fixed CVE-2021-39947 (Closes: #1016138).
    + fixed FTBFS with raven-go 0.2 (Closes: #1005382).
    + fixed FTBFS "TestConfigParse failure" (Closes: #1010124).
  * Removed "gorilla-context-dev" from Build-Depends (Closes: #1023116).
  * Fixed FTBFS (test failure) (Closes: #1010452).
  * Corrected Build-Deps (Closes: #1014427).
    Thanks, Steve Langasek.
  * Standards-Version: 4.6.2.
  * New MUT component "vendor" with private Golang dependencies.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 23 Mar 2023 18:04:35 +1100

=== debian/control ===
--- 
+++ 
@@ -1,56 +1,93 @@
 Source: gitlab-ci-multi-runner
 Section: devel
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Maintainer: Dmitry Smirnov <onlyjob@debian.org>
 Uploaders: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
-Build-Depends: debhelper-compat (= 12) ,dh-golang
-              ,golang-any (>= 2:1.13~)
+Build-Depends: debhelper-compat (= 12) ,dh-golang (>= 1.58~)
+              ,golang-any (>= 2:1.19~)
+    ,golang-github-azure-azure-pipeline-go-dev
+    ,golang-github-azure-azure-storage-blob-go-dev
     ,golang-github-azure-go-ansiterm-dev
     ,golang-github-azure-go-autorest-dev (>= 14.1.1~)
     ,golang-github-blang-semver-dev
     ,golang-github-bmatcuk-doublestar-dev
     ,golang-github-burntsushi-toml-dev
-    ,golang-github-docker-docker-credential-helpers-dev (>= 0.5.0~)
+    ,golang-github-creack-pty-dev (>= 1.1.18~)
+    ,golang-github-docker-distribution-dev
+    ,golang-github-docker-docker-credential-helpers-dev
     ,golang-github-docker-docker-dev (>= 20.10.0~beta1)
-#       ,golang-github-docker-distribution-dev
     ,golang-github-docker-go-connections-dev (>= 0.4.0~)
     ,golang-github-docker-go-units-dev
     ,golang-github-docker-spdystream-dev
     ,golang-github-dustin-go-humanize-dev
-    ,golang-github-emicklei-go-restful-dev (>= 2.4.0~)
+    ,golang-github-elazarl-go-bindata-assetfs-dev
+    ,golang-github-emicklei-go-restful-dev
     ,golang-github-emicklei-go-restful-swagger12-dev
+    ,golang-github-fullsailor-pkcs7-dev
     ,golang-github-getsentry-raven-go-dev
+    ,golang-github-getsentry-sentry-go-dev
     ,golang-github-ghodss-yaml-dev
     ,golang-github-gofrs-flock-dev
+    ,golang-github-gogo-protobuf-dev
     ,golang-github-go-ini-ini-dev
+    ,golang-github-golang-groupcache-dev
+    ,golang-github-golang-snappy-dev
+    ,golang-github-go-logr-logr-dev
+    ,golang-github-googleapis-gax-go-dev
     ,golang-github-googleapis-gnostic-dev
+    ,golang-github-google-go-cmp-dev (>= 0.5.9~)
     ,golang-github-google-gofuzz-dev
+    ,golang-github-google-uuid-dev
+    ,golang-github-google-wire-dev
     ,golang-github-gophercloud-gophercloud-dev
     ,golang-github-gorhill-cronexpr-dev
-    ,golang-github-gorilla-context-dev
     ,golang-github-gorilla-mux-dev
+    ,golang-github-gorilla-websocket-dev
+    ,golang-github-hashicorp-go-sockaddr-dev
     ,golang-github-hashicorp-go-version-dev
     ,golang-github-howeyc-gopass-dev
     ,golang-github-imdario-mergo-dev
     ,golang-github-jpillora-backoff-dev
     ,golang-github-json-iterator-go-dev
+    ,golang-github-kardianos-service-dev
+    ,golang-github-klauspost-compress-dev (>= 1.15.12~)
+    ,golang-github-klauspost-cpuid-dev
+    ,golang-github-klauspost-pgzip-dev
     ,golang-github-kr-pty-dev
     ,golang-github-mattn-go-zglob-dev
-    ,golang-github-minio-minio-go-dev (>= 6.0.11~)
+    ,golang-github-minio-md5-simd-dev
+    ,golang-github-minio-minio-go-v7-dev
+    ,golang-github-minio-sha256-simd-dev
+    ,golang-github-mitchellh-go-homedir-dev
+    ,golang-github-mitchellh-mapstructure-dev
+    ,golang-github-moby-term-dev
+    ,golang-github-morikuni-aec-dev
+    ,golang-github-pierrec-lz4-dev
     ,golang-github-pkg-errors-dev
     ,golang-github-pmezard-go-difflib-dev
-    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
+    ,golang-github-prometheus-client-golang-dev (>= 1.11.1~)
+    ,golang-github-rs-xid-dev
+    ,golang-github-ryanuber-go-glob-dev
     ,golang-github-sirupsen-logrus-dev (>= 1.0.6~)
     ,golang-github-spf13-pflag-dev
-    ,golang-github-stretchr-testify-dev (>= 1.2.1~)
+    ,golang-github-stretchr-testify-dev (>= 1.8.0~)
+    ,golang-github-tevino-abool-dev
     ,golang-github-urfave-cli-dev
+    ,golang-gocloud-dev
     ,golang-golang-x-crypto-dev
     ,golang-golang-x-oauth2-google-dev
     ,golang-golang-x-sync-dev
+    ,golang-google-api-dev
     ,golang-google-cloud-dev
+    ,golang-google-grpc-dev
+    ,golang-google-protobuf-dev (>= 1.27.1~)
     ,golang-gopkg-inf.v0-dev
+    ,golang-gopkg-ini.v1-dev
+    ,golang-gopkg-square-go-jose.v2-dev
+    ,golang-gopkg-yaml.v3-dev
     ,golang-yaml.v2-dev
+    ,mockery
 # tests:
     ,ca-certificates
     ,git

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 VER  ?= $(shell sh -c 'printf "$${1%%+dfsg*}"' -- "$(DEB_VERSION_UPSTREAM)")
 
 export DH_GOLANG_GO_GENERATE := 1
+
 export DH_GOPKG = gitlab.com/gitlab-org/gitlab-runner
 export DH_GOPKG_common = $(DH_GOPKG)/common
 #export DH_GOLANG_INSTALL_EXTRA := vendor
@@ -26,7 +27,7 @@
 override_dh_clean:
 	dh_clean $(MKPI)
 	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
-	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
+	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded[^:]*:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
 	-find vendor -type d -empty -delete -print
 	-find . -type f -name '*.generated.go' -print -delete ## delete .generated.go files

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s{[+~]dfsg\d*}{},\
" https://gitlab.com/gitlab-org/gitlab-runner/-/tags?page=2 \
  .*/v?(\d[\.\d]*)/gitlab-runner-v?(?:\d[\.\d]*)\.tar\.bz2  debian ./debian/get-orig-source.sh
